/*
	TVTest vOCTv

	HDUS̃Rg
*/


#include <windows.h>
#include <tchar.h>
#include <shlwapi.h>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT
#include "TVTestPlugin.h"
#include "HDUSRemocon_KeyHook.h"
#include "resource.h"

#pragma comment(lib,"shlwapi.lib")


// Rg[
#define HDUS_REMOCON_NAME L"DYUD Remocon"

// {^̃Xg
static const struct {
	TVTest::ControllerButtonInfo Info;
	BYTE KeyCode;
	BYTE Modifiers;
} g_ButtonList[] = {
	{{L"d",			L"Close",				{ 5,  9,16,16}, { 5,  9}},	VK_F13,		MK_CONTROL},
	{{L"[h؊",	NULL,					{23,  9,16,16}, {23,  9}},	VK_F14,		MK_CONTROL},
	{{L"؊",		L"SwitchAudio",			{41,  9,16,16}, {41,  9}},	VK_F15,		MK_CONTROL},
	{{L"f؊",		NULL,					{59,  9,16,16}, {59,  9}},	VK_F16,		MK_CONTROL},
	{{L"",			NULL,					{ 5, 27,16,16}, { 5, 27}},	VK_F17,		MK_CONTROL},
	{{L"S",		L"Fullscreen",			{23, 27,16,16}, {23, 27}},	VK_F18,		MK_CONTROL},
	{{L"ʕ\",		L"AspectRatio",			{41, 27,16,16}, {41, 27}},	VK_F19,		MK_CONTROL},
	{{L"",			L"Mute",				{59, 27,16,16}, {59, 27}},	VK_F20,		MK_CONTROL},
	{{L"`l1",	L"Channel1",			{ 5, 45,16,16}, { 5, 45}},	VK_F21,		MK_CONTROL},
	{{L"`l2",	L"Channel2",			{23, 45,16,16}, {23, 45}},	VK_F22,		MK_CONTROL},
	{{L"`l3",	L"Channel3",			{41, 45,16,16}, {41, 45}},	VK_F23,		MK_CONTROL},
    //ʁ{
	{{L"`l4",	L"Channel4",			{ 5, 63,16,16}, { 5, 63}},	VK_F24,		MK_CONTROL},
	{{L"`l5",	L"Channel5",			{23, 63,16,16}, {23, 63}},	VK_F13,		MK_SHIFT},
	{{L"`l6",	L"Channel6",			{41, 63,16,16}, {41, 63}},	VK_F14,		MK_SHIFT},
    //ʁ|
	{{L"`l7",	L"Channel7",			{ 5, 81,16,16}, { 5, 81}},	VK_F15,		MK_SHIFT},
	{{L"`l8",	L"Channel8",			{23, 81,16,16}, {23, 81}},	VK_F16,		MK_SHIFT},
	{{L"`l9",	L"Channel9",			{41, 81,16,16}, {41, 81}},	VK_F17,		MK_SHIFT},
    //`l
	{{L"`l10",	L"Channel10",			{ 5, 99,16,16}, { 5, 99}},	VK_F18,		MK_SHIFT},
	{{L"`l11",	L"Channel11",			{23, 99,16,16}, {23, 99}},	VK_F19,		MK_SHIFT},
	{{L"`l12",	L"Channel12",			{41, 99,16,16}, {41, 99}},	VK_F20,		MK_SHIFT},
    //`l
	{{L"^CVtg",	L"SaveImage",			{ 5,117,16,16}, { 5,117}},	VK_F21,		MK_SHIFT},
    //
	{{L"3",		NULL,					{41,117,16,16}, {41,117}},	VK_F22,		MK_SHIFT},
	{{L"ԑg\",		L"ProgramGuide",		{59,117,16,16}, {59,117}},	VK_F23,		MK_SHIFT},
    //
    //
    //
	{{L"^u",			L"ChannelMenu",			{59,135,16,16}, {59,135}},	VK_F24,		MK_SHIFT},
	{{L"^",			L"RecordStart",			{ 5,153,16,16}, { 5,153}},	VK_F13,		MK_CONTROL | MK_SHIFT},
    //
	{{L"j[",		L"Menu",				{41,153,16,16}, {41,153}},	VK_F14,		MK_CONTROL | MK_SHIFT},
	{{L"߂",			NULL,					{59,153,16,16}, {59,153}},	VK_F15,		MK_CONTROL | MK_SHIFT},
	{{L"~",			L"RecordStop",			{ 5,171,16,16}, { 5,171}},	VK_F16,		MK_CONTROL | MK_SHIFT},
	{{L"Đ",			NULL,					{23,171,16,16}, {23,171}},	VK_F17,		MK_CONTROL | MK_SHIFT},
	{{L"ꎞ~",		L"RecordPause",			{41,171,16,16}, {41,171}},	VK_F18,		MK_CONTROL | MK_SHIFT},
	{{L"",		L"ChannelDisplayMenu",	{59,171,16,16}, {59,171}},	VK_F19,		MK_CONTROL | MK_SHIFT},
	{{L"|<<",			NULL,					{ 5,189,16,16}, { 5,189}},	VK_F20,		MK_CONTROL | MK_SHIFT},
	{{L"<<",			NULL,					{23,189,16,16}, {23,189}},	VK_F21,		MK_CONTROL | MK_SHIFT},
	{{L">>",			NULL,					{41,189,16,16}, {41,189}},	VK_F22,		MK_CONTROL | MK_SHIFT},
	{{L">>|",			NULL,					{59,189,16,16}, {59,189}},	VK_F23,		MK_CONTROL | MK_SHIFT},
#if 0                                                                            
	{{L" +",		L"VolumeUp",			{59, 45,16,16}, {59, 45}},	VK_UP,		MK_SHIFT},
	{{L" -",		L"VolumeDown",			{59, 63,16,16}, {59, 63}},	VK_DOWN,	MK_SHIFT},
	{{L"`l +",	L"ChannelUp",			{59, 81,16,16}, {59, 81}},	VK_UP,		MK_CONTROL},
	{{L"`l -",	L"ChannelDown",			{59, 99,16,16}, {59, 99}},	VK_DOWN,	MK_CONTROL},
#endif                                                                           
};

#define NUM_BUTTONS (sizeof(g_ButtonList)/sizeof(g_ButtonList[0]))


// vOCNX
class CDYUDRemocon : public TVTest::CTVTestPlugin
{
	bool m_fInitialized;	// ς݂?
	HMODULE m_hLib;			// tbNDLL̃nh
	bool m_fHook;			// tbNĂ邩?
	static UINT m_Message;	// tbNDLL瑗郁bZ[W

	bool InitializePlugin();
	bool BeginHook();
	bool EndHook();
	bool SetWindow(HWND hwnd);
	void OnError(LPCWSTR pszMessage);

	static LRESULT CALLBACK EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData);
	static BOOL CALLBACK MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
										 LRESULT *pResult,void *pClientData);
	static BOOL CALLBACK TranslateMessageCallback(HWND hwnd,MSG *pMessage,void *pClientData);

public:
	CDYUDRemocon();
	virtual bool GetPluginInfo(TVTest::PluginInfo *pInfo);
	virtual bool Initialize();
	virtual bool Finalize();
};


UINT CDYUDRemocon::m_Message=0;


CDYUDRemocon::CDYUDRemocon()
	: m_fInitialized(false)
	, m_hLib(NULL)
	, m_fHook(false)
{
}


bool CDYUDRemocon::GetPluginInfo(TVTest::PluginInfo *pInfo)
{
	// vOC̏Ԃ
	pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
	pInfo->Flags          = 0;
	pInfo->pszPluginName  = L"DY-UD200R";
	pInfo->pszCopyright   = L"Public Domain";
	pInfo->pszDescription = L"DY-UD200̃RɑΉ܂B";
	return true;
}


bool CDYUDRemocon::Initialize()
{
	// 

	// {^̃Xg쐬
	TVTest::ControllerButtonInfo ButtonList[NUM_BUTTONS];
	for (int i=0;i<NUM_BUTTONS;i++)
		ButtonList[i]=g_ButtonList[i].Info;

	// Rg[̓o^
	TVTest::ControllerInfo Info;
	Info.Flags             = 0;
	Info.pszName           = HDUS_REMOCON_NAME;
	Info.pszText           = L"DY-UD200R";
	Info.NumButtons        = NUM_BUTTONS;
	Info.pButtonList       = ButtonList;
	Info.pszIniFileName    = NULL;
	Info.pszSectionName    = L"DYUDController";
	Info.ControllerImageID = IDB_CONTROLLER;
	Info.SelButtonsImageID = IDB_SELBUTTONS;
	Info.pTranslateMessage = TranslateMessageCallback;
	Info.pClientData       = this;
	if (!m_pApp->RegisterController(&Info)) {
		m_pApp->AddLog(L"Rg[o^ł܂B");
		return false;
	}

	// CxgR[obN֐o^
	m_pApp->SetEventCallback(EventCallback,this);

	return true;
}


// vOCLɂꂽ̏
bool CDYUDRemocon::InitializePlugin()
{
	if (!m_fInitialized) {
		// bZ[W̓o^
		m_Message=::RegisterWindowMessage(KEYHOOK_MESSAGE);
		if (m_Message==0)
			return false;

		// Vista/7 ŊǗҌŎsꂽp̑΍
#ifndef MSGFLT_ADD
#define MSGFLT_ADD 1
#endif
		typedef BOOL (WINAPI *ChangeWindowMessageFilterFunc)(UINT,DWORD);
		HMODULE hLib=::LoadLibrary(TEXT("user32.dll"));
		ChangeWindowMessageFilterFunc pChangeFilter=
			(ChangeWindowMessageFilterFunc)::GetProcAddress(hLib,"ChangeWindowMessageFilter");
		if (pChangeFilter!=NULL)
			pChangeFilter(m_Message,MSGFLT_ADD);
		::FreeLibrary(hLib);

		m_fInitialized=true;
	}

	// bZ[WR[obN֐o^
	m_pApp->SetWindowMessageCallback(MessageCallback,this);

	return true;
}


bool CDYUDRemocon::Finalize()
{
	// I

	// tbNI
	if (m_hLib!=NULL) {
		EndHook();
		::FreeLibrary(m_hLib);
		m_hLib=NULL;
	}

	return true;
}


bool CDYUDRemocon::BeginHook()
{
	// tbNJn

	if (m_hLib==NULL) {
		TCHAR szFileName[MAX_PATH];

		::GetModuleFileName(g_hinstDLL,szFileName,MAX_PATH);
		::lstrcpy(::PathFindExtension(szFileName),TEXT("_KeyHook.dll"));
		m_hLib=::LoadLibrary(szFileName);
		if (m_hLib==NULL)
			return false;
	}

	BeginHookFunc pBeginHook;
	pBeginHook=(BeginHookFunc)::GetProcAddress(m_hLib,"BeginHook");
	if (pBeginHook==NULL
			|| !pBeginHook(m_pApp->GetAppWindow(),
						   m_pApp->IsControllerActiveOnly(HDUS_REMOCON_NAME))) {
		::FreeLibrary(m_hLib);
		m_hLib=NULL;
		return false;
	}
	m_fHook=true;

	return true;
}


bool CDYUDRemocon::EndHook()
{
	// tbNI

	if (m_fHook) {
		EndHookFunc pEndHook;

		pEndHook=(EndHookFunc)::GetProcAddress(m_hLib,"EndHook");
		if (pEndHook==NULL)
			return false;
		pEndHook();
		m_fHook=false;
	}
	return true;
}


bool CDYUDRemocon::SetWindow(HWND hwnd)
{
	// EBhEݒ

	if (!m_fHook)
		return false;
	SetWindowFunc pSetWindow=(SetWindowFunc)::GetProcAddress(m_hLib,"SetWindow");
	if (pSetWindow==NULL)
		return false;
	return pSetWindow(hwnd)!=FALSE;
}


void CDYUDRemocon::OnError(LPCWSTR pszMessage)
{
	// G[̃bZ[W\
	m_pApp->AddLog(pszMessage);
	if (!m_pApp->GetSilentMode()) {
		::MessageBoxW(m_pApp->GetAppWindow(),pszMessage,L"DY-UD200R",
					  MB_OK | MB_ICONEXCLAMATION);
	}
}


// CxgR[obN֐
// CxgNƌĂ΂
LRESULT CALLBACK CDYUDRemocon::EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData)
{
	CDYUDRemocon *pThis=static_cast<CDYUDRemocon*>(pClientData);

	switch (Event) {
	case TVTest::EVENT_PLUGINENABLE:
		// vOC̗LԂω
		if (lParam1!=0) {
			if (!pThis->InitializePlugin()) {
				pThis->OnError(L"ŃG[܂B");
				return FALSE;
			}
			if (!pThis->BeginHook()) {
				pThis->OnError(L"tbNł܂B");
				return FALSE;
			}
		} else {
			pThis->EndHook();
			pThis->m_pApp->SetWindowMessageCallback(NULL);
		}
		return TRUE;

	case TVTest::EVENT_CONTROLLERFOCUS:
		// ̃vZX̑ΏۂɂȂ
		pThis->SetWindow(reinterpret_cast<HWND>(lParam1));
		return TRUE;
	}
	return 0;
}


// bZ[WR[obN֐
BOOL CALLBACK CDYUDRemocon::MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
											LRESULT *pResult,void *pClientData)
{
	if (uMsg==m_Message) {
		// tbNDLL瑗郁bZ[W

		if (KEYHOOK_GET_REPEATCOUNT(lParam)>1)
			return 0;

		BYTE Modifiers=0;
		if (KEYHOOK_GET_CONTROL(lParam))
			Modifiers|=MK_CONTROL;
		if (KEYHOOK_GET_SHIFT(lParam))
			Modifiers|=MK_SHIFT;
		WORD KeyCode=(WORD)wParam;

		// ꂽ{^T
		for (int i=0;i<NUM_BUTTONS;i++) {
			if (g_ButtonList[i].KeyCode==KeyCode
					&& g_ButtonList[i].Modifiers==Modifiers) {
				CDYUDRemocon *pThis=static_cast<CDYUDRemocon*>(pClientData);

				// {^ꂽƂʒm
				pThis->m_pApp->OnControllerButtonDown(HDUS_REMOCON_NAME,i);
				break;
			}
		}
		return TRUE;
	}
	return FALSE;
}


// bZ[W̕ϊR[obN
// Shift+ Ȃǂ̓tbNƖ肠̂łŏĂ܂
BOOL CALLBACK CDYUDRemocon::TranslateMessageCallback(HWND hwnd,MSG *pMessage,void *pClientData)
{
	if (pMessage->message==WM_KEYDOWN
			&& (pMessage->wParam==VK_UP || pMessage->wParam==VK_DOWN)) {
		bool fShift=::GetKeyState(VK_SHIFT)<0;
		bool fCtrl=::GetKeyState(VK_CONTROL)<0;

		// ǂ炩Ăꍇ̂ݏ
		if (fShift!=fCtrl) {
			CDYUDRemocon *pThis=static_cast<CDYUDRemocon*>(pClientData);

			pThis->m_pApp->DoCommand(
				pMessage->wParam==VK_UP?(fShift?L"VolumeUp":L"ChannelUp"):
										(fShift?L"VolumeDown":L"ChannelDown"));
			return TRUE;
		}
	}
	return FALSE;
}




// vOCNX̃CX^X𐶐
TVTest::CTVTestPlugin *CreatePluginClass()
{
	return new CDYUDRemocon;
}
